#pragma once

using namespace System;
using namespace System::Runtime::InteropServices;
using namespace System::Windows::Forms;
using namespace System::Text;

//using namespace System::Collections;


#using <mscorlib.dll>

// Important notice:
// in file "WSQImageLibraryNativeMethods32.h"
// "namespace" must match the "namespace" of the main project
namespace wsq_demo
{
	private ref class WSQImageLibraryNativeMethods32
	{

	public:
		WSQImageLibraryNativeMethods32()
		{
		}


		static UTF8Encoding ^utf8 = gcnew UTF8Encoding;

		static System::IntPtr wsq_decompressed_byte_array_ptr = System::IntPtr::Zero;
		static System::IntPtr out_comment_text_ptr = System::IntPtr::Zero;
		static System::IntPtr wsq_compressed_byte_array_ptr = System::IntPtr::Zero;
		static System::IntPtr bitmap_ptr = System::IntPtr::Zero;


	private:
		[DllImport("WSQ_library.dll", CallingConvention = CallingConvention::Cdecl, CharSet = CharSet::Unicode)]
		static void _RegisterWSQ();
	public:
		void pRegisterWSQ()
		{
			try
			{
				
				_RegisterWSQ();
				
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "RegisterWSQ Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
		}

		
		
	private:
		[DllImport("WSQ_library.dll", CallingConvention = CallingConvention::Cdecl, CharSet = CharSet::Unicode)]
		static IntPtr _CreateBMPFromFile(array<System::Byte> ^lpszFileName);
	public:
		IntPtr pCreateBMPFromFile(System::String ^FileName)
		{

			if (FileName == nullptr)
				throw gcnew ArgumentNullException("FileName should be not null");
			if (FileName->Length == 0)
				throw gcnew ArgumentException("Incorrect file name");
			try
			{
				
				//return _CreateBMPFromFile(utf8->GetBytes(FileName));
				bitmap_ptr = _CreateBMPFromFile(utf8->GetBytes(FileName));
                return bitmap_ptr;

			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "CreateBMPFromFile Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
			
			return IntPtr::Zero;
			
		}
		
		

	private:
		[DllImport("WSQ_library.dll", CallingConvention = CallingConvention::Cdecl, CharSet = CharSet::Unicode)]
		static int _SaveBMPToFile(IntPtr hBitmap, array<System::Byte> ^filename, [MarshalAs(UnmanagedType::I4)] int filetype);
	public:
		int pSaveBMPToFile(IntPtr Bitmap, System::String ^FileName, int FileType)
		{
			int retVal = -1;
			
			if (Bitmap == (IntPtr)nullptr)
				throw gcnew ArgumentNullException("Bitmap should be not null");
			if (FileName == nullptr)
				throw gcnew ArgumentNullException("FileName should be not null");			
			if (FileName->Length == 0)
				throw gcnew ArgumentException("Incorrect file name");
			
			try
			{
				
				retVal = _SaveBMPToFile(Bitmap, utf8->GetBytes(FileName), FileType);
				
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "SaveBMPToFile Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
			
			return retVal;
			
		}


	private:
		[DllImport("WSQ_library.dll", CallingConvention = CallingConvention::Cdecl, CharSet = CharSet::Unicode)]
		static IntPtr _CreateBMPFromWSQByteArray([In] array<System::Byte> ^input_wsq_compressed_byte_array, 
			[In, MarshalAs(UnmanagedType::I4)] int input_wsq_compressed_byte_array_length);
	public:
		IntPtr pCreateBMPFromWSQByteArray([In] array<System::Byte> ^input_wsq_compressed_byte_array, [In] Int32 input_wsq_compressed_byte_array_length)
		{

			try
			{
				
				IntPtr bitmap_local(_CreateBMPFromWSQByteArray(input_wsq_compressed_byte_array, input_wsq_compressed_byte_array_length));
				return bitmap_local;
				
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "CreateBMPFromWSQByteArray Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
			
			return IntPtr::Zero;
			
		}


	private:
		[DllImport("WSQ_library.dll", CallingConvention = CallingConvention::Cdecl, CharSet = CharSet::Unicode)]
		static int _SaveWSQByteArrayToImageFile([In] array<System::Byte> ^input_wsq_compressed_byte_array, [In, MarshalAs(UnmanagedType::I4)] int input_wsq_compressed_byte_array_length, array<System::Byte> ^filename, [MarshalAs(UnmanagedType::I4)] int filetype);
	public:
		int pSaveWSQByteArrayToImageFile([In] array<System::Byte> ^input_wsq_compressed_byte_array, [In] Int32 input_wsq_compressed_byte_array_length, System::String ^FileName, int FileType)
		{
			int retVal = -1;
			
			if (FileName == nullptr)
									 throw gcnew ArgumentNullException("FileName should be not null");
			if (FileName->Length == 0)
				throw gcnew ArgumentException("Incorrect file name");

			try
			{
				
				retVal = _SaveWSQByteArrayToImageFile(input_wsq_compressed_byte_array, input_wsq_compressed_byte_array_length, utf8->GetBytes(FileName), FileType);
				
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "SaveWSQByteArrayToImageFile Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
			
			return retVal;
			
		}





	private:
		[DllImport("WSQ_library.dll", CallingConvention = CallingConvention::Cdecl, CharSet = CharSet::Unicode)]
		static void _SetShowFilePropertiesDialog([MarshalAs(UnmanagedType::I4)] int file_properties_dialog);
	public:
		void pSetShowFilePropertiesDialog(int file_properties_dialog)
		{
			try
			{
				
				_SetShowFilePropertiesDialog(file_properties_dialog);
				
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "SetShowFilePropertiesDialog Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
		}





	private:
		[DllImport("WSQ_library.dll", CallingConvention = CallingConvention::Cdecl, CharSet = CharSet::Unicode)]
		static int _WSQ_decode_stream(
			[In] array<System::Byte> ^input_wsq_compressed_byte_array,
			[In, MarshalAs(UnmanagedType::I4)] int input_wsq_compressed_byte_array_length, 
			[System::Runtime::InteropServices::Out] unsigned char** output_decompressed_byte_array, 
			[System::Runtime::InteropServices::Out, MarshalAs(UnmanagedType::I4)] int %width, 
			[System::Runtime::InteropServices::Out, MarshalAs(UnmanagedType::I4)] int %height, 
			[System::Runtime::InteropServices::Out, MarshalAs(UnmanagedType::I4)] int %ppi, 
			[System::Runtime::InteropServices::Out] char** comment_text);
			
	public:
		int pWSQ_decode_stream(
			[In] array<System::Byte> ^input_wsq_compressed_byte_array,
			[In] Int32 input_wsq_compressed_byte_array_length,
			[System::Runtime::InteropServices::Out] array<System::Byte> ^%output_decompressed_byte_array,
			[System::Runtime::InteropServices::Out] Int32 %width, [System::Runtime::InteropServices::Out] Int32 %height,
			[System::Runtime::InteropServices::Out] Int32 %ppi,
			[System::Runtime::InteropServices::Out] System::String ^%comment_text)
		
		{
			int retVal = -1;
			
			output_decompressed_byte_array = gcnew array<System::Byte>(1);
			
			width = height = ppi = 0;
			comment_text = String::Empty;
			
			try
			{
				
				static unsigned char* wsq_decompressed_byte_array = nullptr;
				static char* out_comment_text = nullptr;				
				
				retVal = _WSQ_decode_stream(input_wsq_compressed_byte_array, input_wsq_compressed_byte_array_length, 
					&wsq_decompressed_byte_array, width, height, ppi, &out_comment_text);

				IntPtr wsq_decompressed_byte_array_ptr(wsq_decompressed_byte_array);
				IntPtr out_comment_text_ptr(out_comment_text);

				comment_text = Marshal::PtrToStringAnsi(out_comment_text_ptr);
				int lenght = width * height;
				output_decompressed_byte_array = gcnew array<System::Byte>(lenght);
				Marshal::Copy(wsq_decompressed_byte_array_ptr, output_decompressed_byte_array, 0, lenght);
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "WSQ_decode_stream Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
			
			return retVal;
			
		}


		

	private:
		[DllImport("WSQ_library.dll", CallingConvention = CallingConvention::Cdecl, CharSet = CharSet::Unicode)]
		static int _WSQ_encode_stream([In] array<System::Byte> ^input_byte_array, 
			[In, MarshalAs(UnmanagedType::I4)] int width, 
			[In, MarshalAs(UnmanagedType::I4)] int height, 
			[In, MarshalAs(UnmanagedType::R8)] double bitrate, 
			[In, MarshalAs(UnmanagedType::I4)] int ppi, 
			[In] array<System::Byte> ^commentText, 
			[System::Runtime::InteropServices::Out] unsigned char** output_compressed_byte_array, 
			[System::Runtime::InteropServices::Out] int %output_compressed_byte_array_length);
			
	public:
		int pWSQ_encode_stream(array<System::Byte> ^input_byte_array, int width, int height, 
			double bitrate, int ppi, System::String ^commentText, 
			[System::Runtime::InteropServices::Out] array<System::Byte> ^%output_compressed_byte_array, 
			[System::Runtime::InteropServices::Out] int %output_compressed_byte_array_length)			
		{
			int retVal = -1;
			
			output_compressed_byte_array = gcnew array<System::Byte>(1);
			
			output_compressed_byte_array_length = 0;
			
			try
			{
				static unsigned char* wsq_compressed_byte_array = nullptr;				
				
				retVal = _WSQ_encode_stream(input_byte_array, width, height, bitrate, ppi, 
					utf8->GetBytes(commentText), &wsq_compressed_byte_array, output_compressed_byte_array_length);

				if (output_compressed_byte_array_length == 0)
					throw gcnew ArgumentException("output_compressed_byte_array_length == 0");


				IntPtr wsq_compressed_byte_array_ptr( wsq_compressed_byte_array );
				
				output_compressed_byte_array = gcnew array<System::Byte>(output_compressed_byte_array_length);
				Marshal::Copy(wsq_compressed_byte_array_ptr, output_compressed_byte_array, 0, output_compressed_byte_array_length);
				
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "WSQ_encode_stream Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
			
			return retVal;
			
		}
		
		
		
		

	private:
		[DllImport("WSQ_library.dll", CallingConvention = CallingConvention::Cdecl, CharSet = CharSet::Unicode)]
		static IntPtr _ConvertHBITMAPtoGrayScale256(IntPtr hBitmap);
	public:
		IntPtr pConvertHBITMAPtoGrayScale256(IntPtr Bitmap)
		{
			try
			{
				
				return _ConvertHBITMAPtoGrayScale256(Bitmap);
				
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "ConvertHBITMAPtoGrayScale256 Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
			
			return IntPtr::Zero;
			
		}


	private:
		[DllImport("WSQ_library.dll", CallingConvention = CallingConvention::Cdecl, CharSet = CharSet::Unicode)]
		static int _SaveHBITMAPtoFileAsGrayScale256BMP(IntPtr hBitmap, array<System::Byte> ^filename);
	public:
		int pSaveHBITMAPtoFileAsGrayScale256BMP(IntPtr Bitmap, System::String ^FileName)
		{
			int retVal = -1;
			
			if (Bitmap == (IntPtr)nullptr)
				throw gcnew ArgumentNullException("Bitmap should be not null");
			if (FileName == nullptr)
				throw gcnew ArgumentNullException("FileName should be not null");			
			if (FileName->Length == 0)
				throw gcnew ArgumentException("Incorrect file name");
			
			try
			{
				
				retVal = _SaveHBITMAPtoFileAsGrayScale256BMP(Bitmap, utf8->GetBytes(FileName));
				
			}
			catch (Exception ^ex)
			{
				MessageBox::Show(ex->Message, "SaveHBITMAPtoFileAsGrayScale256BMP Exception", MessageBoxButtons::OK, MessageBoxIcon::Error);
			}
			
			return retVal;
			
		}
	};
}